//+------------------------------------------------------------------+
//|                                              #MTF_AFStar.mq4     |
//|------------------------------------------------------------------+

#property indicator_chart_window
#property  indicator_buffers 2
#property  indicator_color1 Red
#property  indicator_color2 Yellow
#property indicator_width1 4 
#property indicator_width2 4 
//---- input parameters
/*************************************************************************
PERIOD_M1   1
PERIOD_M5   5
PERIOD_M15  15
PERIOD_M30  30 
PERIOD_H1   60
PERIOD_H4   240
PERIOD_D1   1440
PERIOD_W1   10080
PERIOD_MN1  43200
You must use the numeric value of the timeframe that you want to use
when you set the TimeFrame' value with the indicator inputs.
---------------------------------------*/

extern int    TimeFrame = 15;
double     ExtBuffer0[];
double     ExtBuffer1[];
extern bool SoundAlert = true;
double alertBar;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+

int init()
  {
   
//---- indicator line
   SetIndexStyle(0,DRAW_ARROW);
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexBuffer(0,ExtBuffer0);
      SetIndexEmptyValue(0,0.0);
   SetIndexBuffer(1,ExtBuffer1);
      SetIndexEmptyValue(1,0.0);
    SetIndexArrow(0,226);
    SetIndexArrow(1,225);
      IndicatorDigits(Digits+1);
   SetIndexLabel(0,NULL);
   SetIndexLabel(1,NULL);
//---- name for DataWindow and indicator subwindow label   

   switch(TimeFrame)
   {
      case 1 : string TimeFrameStr="Period_M1"; break;
      case 5 : TimeFrameStr="Period_M5"; break;
      case 15 : TimeFrameStr="Period_M15"; break;
      case 30 : TimeFrameStr="Period_M30"; break;
      case 60 : TimeFrameStr="Period_H1"; break;
      case 240 : TimeFrameStr="Period_H4"; break;
      case 1440 : TimeFrameStr="Period_D1"; break;
      case 10080 : TimeFrameStr="Period_W1"; break;
      case 43200 : TimeFrameStr="Period_MN1"; break;
      default : TimeFrameStr="Current Timeframe";
   }
   IndicatorShortName("#MTF_Sar("+TimeFrameStr+")");

  }

//----

   return(0);
 
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int start()
  {

   datetime TimeArray[];
   int    i,limit,y=0,counted_bars=IndicatorCounted(); 

// Plot defined time frame on to current time frame

   ArrayCopySeries(TimeArray,MODE_TIME,Symbol(),TimeFrame); 
   
   limit= Bars-1;
   for(i=0,y=0;i<limit;i++)
   {
   if (Time[i]<TimeArray[y]) y++;

/***********************************************************   
   Add your main indicator loop below.  You can reference an existing
      indicator with its iName  or iCustom.
   Rule 1:  Add extern inputs above for all neccesary values   
   Rule 2:  Use 'TimeFrame' for the indicator time frame
   Rule 3:  Use 'y' for your indicator's shift value
 **********************************************************/  
 

    if (Time[i]==TimeArray[y])ExtBuffer0[i]=iCustom(Symbol(),TimeFrame,"AFStar",0,y);
    if (Time[i]==TimeArray[y])ExtBuffer1[i]=iCustom(Symbol(),TimeFrame,"AFStar",1,y); 
    if(i == 1 && Time[i]==TimeArray[y] && ExtBuffer0[i] > ExtBuffer1[i] && ExtBuffer0[i] != EMPTY_VALUE && ExtBuffer1[i] != EMPTY_VALUE && SoundAlert == true && Bars>alertBar) {Alert("#MTF Arrows going Up " + " on the " +  Period() + " minute chart.");alertBar = Bars;}
    if(i == 1 && Time[i]==TimeArray[y] && ExtBuffer0[i] < ExtBuffer1[i] && ExtBuffer0[i] != EMPTY_VALUE && ExtBuffer1[i] != EMPTY_VALUE && SoundAlert == true && Bars>alertBar) {Alert("#MTF Arrows going Down " + " on the " +  Period() + " minute chart.");alertBar = Bars;}
   }
   return(0);
  }
//+------------------------------------------------------------------+